﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7.28
@EndOfDesignText@
'Static code module

#Region Comment
	'This module was written a while ago to help me tidy my code which was full of inconsistencies related to my typing habits
	'Here it is being reused to standardize the format of the code which helps to simplify the translation to JS
	
	'It uses a dictionary (term.txt in the Objects folder) to replace bad capitalization with the standard one
	'In this application it also replaces BX4 terms with the corresponding JS terms
	'There are about 600 terms in this dictionary. However, it is incomplete and must be expanded for more general use (B4A, B4i). 
	
	'The module only tidies valid B4X terms. The B4X code should first be tested and validated separately (SAVE the original).
#End Region

Sub Process_Globals
	Private dict As Map
	Public delimiters As String = " ~!%^&*/()-+={[}]|:;'<,>.?"
	Private StringsTokens As Map
	Private TokensStrings As Map
	Private tokens As Long = 100000
	Private smartStart As String = Chr(36) & Chr(34)
	Private smartEnd As String = Chr(34) & Chr(36)
		 		 		 		 		 		 		 		 		 		 		 		 		 		 		 		 
	Private tokenStart As String = Chr(113) & Chr(95)
	Private tokenEnd As String = Chr(95) & Chr(113)
	
	Public vectors As Map
	Private B4XtoJS As Boolean = True

	Private skipNext As String = ""
End Sub

Sub initTables(translateIt As Boolean)
	B4XtoJS = translateIt
	vectors.Initialize
	dict.Initialize
	StringsTokens.Initialize
	TokensStrings.Initialize

	Dim terms As List = File.ReadList(File.DirApp, "terms.txt")
	For Each t As String In terms
		Dim tU As String = t.ToUpperCase
		Dim v() As String = twoParts (t, "=")
		If v(1).Length>0 Then
			tU = v(0).toUpperCase
			If B4XtoJS Then t = v(1) Else t = v(0)
		Else If B4XtoJS Then
			t = t.SubString2(0,1).ToLowerCase & t.SubString(1)
		End If
		If dict.ContainsKey(tU) = False Then dict.Put(tU, t)
	Next
End Sub
           
Sub tidy(cod As String) As String
	vectors.clear
	StringsTokens.Clear
	TokensStrings.Clear

	Dim sb As StringBuilder: sb.Initialize
	Dim buffer As List: buffer.Initialize
	
	cod = tokenizeSmartStrings(cod)
	
	Dim inIf As Boolean = False
	Dim lines() As String = Regex.Split(CRLF, cod)
	For Each s As String In lines
		If s.toLowerCase.IndexOf("#" & "if") > - 1 Then inIf = True
		If inIf Then buffer.Add(s)
           
		If s.toLowerCase.IndexOf("#" & "end if") > - 1 Then inIf = False
		If inIf = False Then
			If buffer.Size > 0 Then
				For Each t As String In buffer
					sb.Append(t & CRLF)
				Next
				buffer.Clear
			Else
				sb.Append(tidyLine(s) & CRLF)
			End If
		End If
	Next
	For Each t As String In buffer
		sb.Append(t & CRLF)
	Next
	sb.Remove(sb.Length-1, sb.Length)
	Return sb.ToString
End Sub
         
Sub tokenizeSmartStrings(cod As String) As String
	Dim sb As StringBuilder: sb.Initialize
	Dim k As Int = cod.IndexOf(" " & smartStart) 
	Do While k > -1
		k = k + 1
		Dim kend As Int = cod.IndexOf2(smartEnd, k + 2)
		Dim theString As String = cod.SubString2(k, kend + 1)
		sb.Append(cod.SubString2(0, k) )
		If StringsTokens.ContainsKey(theString) Then
			sb.Append(StringsTokens.Get(theString) )
		Else
			tokens = tokens + 1
			Dim token As String = tokenStart & tokens & tokenEnd
			StringsTokens.Put(theString, token)
			TokensStrings.Put(token, theString)
			sb.Append(token)
		End If
		cod = cod.SubString(kend + 1)
		k = cod.IndexOf(" " & smartStart)
	Loop
	sb.Append(cod)
	Return sb.ToString
End Sub
         
Sub tidyLine(s As String) As String
	s = s.Replace("_Sub ", "Sub ")
	s = s.Replace("_End Sub", "End Sub")
	Dim klen As Int = s.Length - ltrim(s).Length
	Dim savePrefix As String = s.SubString2(0, klen)
	s = tokenizeQuotes(s.SubString(klen))
	Dim k As Int = s.LastIndexOf("'")
	Dim saveComment As String = ""
	If k > -1 Then
		saveComment = s.SubString(k)
		If B4XtoJS Then saveComment = "//" & s.SubString(k+1)
		s = s.SubString2(0, k)
	End If
	If s.Length > 0 Then
		If s.StartsWith("#") And B4XtoJS Then
			s = "//" & s
		Else if s.IndexOf("Process_Globals")>-1 And B4XtoJS Then
			s = "//" & s
			skipNext = "End Sub"
		Else if s = skipNext Then
			skipNext = ""
			s = "//" & s
		Else	
			s = reinstateStrings(Parse(s) )
		End If
	End If
	Return savePrefix & s & saveComment
End Sub
           
Sub tokenizeQuotes(s As String) As String
	Dim res As String = s
	Dim v() As String = Regex.Split(Chr(34), s & Chr(254) )
	If v.Length > 1 Then
		Dim sb As StringBuilder: sb.Initialize
		sb.Append(v(0) )
		For j = 1 To v.Length-1
			If j Mod 2 = 1 Then
				Dim theString As String = v(j)
				If StringsTokens.ContainsKey(theString) Then
					sb.Append(StringsTokens.Get(theString) )
				Else
					tokens = tokens + 1
					Dim token As String = tokenStart & tokens & tokenEnd
					StringsTokens.Put(theString, token)
					TokensStrings.Put(token, theString)
					sb.Append(token)
				End If
			Else
				sb.Append(v(j) )
			End If
		Next
		Dim res As String = sb.ToString
		res = res.SubString2(0, res.Length-1)
	End If
	Return res
End Sub

Sub Parse(s As String) As String
	Dim parts As List: parts.Initialize
	Dim term As StringBuilder: term.Initialize
	Dim lastDelim As String = ""
	For j = 0 To s.Length - 1							 'the line of code is split into term/delimiter pairs
		Dim c As String = s.CharAt(j)
		If delimiters.IndexOf(c) > -1 Then
			If(term.Length = 0 And c = " " And lastDelim = " ") = False Then
				parts.Add(term.ToString)
				If term.Length > 0 Then term.Remove(0, term.Length)
				parts.Add(c)
			End If
			lastDelim = c
		Else
			term.Append(c)
		End If
	Next
	parts.Add(term.ToString)
	parts.Add("")
	
	Dim sb As StringBuilder: sb.Initialize
	Dim thisWord As String = ""
	Dim thisDelim As String = ""
	For j = 0 To parts.Size - 2 Step 2
		thisWord = parts.Get(j)
		thisDelim = parts.Get(j + 1)
		If "=+*/&><>".IndexOf(thisDelim) > -1 Then
			thisDelim = " " & thisDelim & " "
		Else If ",:)}]".IndexOf(thisDelim) > -1 Then
			thisDelim = thisDelim & " "
		End If
		Dim ucs As String = thisWord.ToUpperCase
		If dict.ContainsKey(ucs) Then thisWord = dict.Get(ucs)
		sb.Append(thisWord & thisDelim)
	Next
	Dim res As String = sb.ToString
	Dim prevRes As String = ""

	Do While res <> prevRes
		prevRes = res
		res = res.Replace("  ", " ")
	Loop
	res = res.Replace(" (", "(").Replace(" {", "{").Replace(" [", "[")
	res = res.Replace(" )", ")").Replace(" }", "}").Replace(" ]", "]")
	res = res.Replace(" ,", ",").Replace(" :", ":").Replace(" .", ".").Replace(" ;", ";")
	If B4XtoJS Then res = translate.JS(res)
	Return res
End Sub
           
Sub reinstateStrings(s As String) As String
	Dim p() As String = Regex.Split(tokenStart, s)
	Dim sb As StringBuilder: sb.Initialize
	sb.Append(p(0) )
	For j = 1 To p.Length - 1
		Dim v() As String = twoParts(p(j), "_")
		Dim theString As String = TokensStrings.Get(tokenStart & v(0) & tokenEnd)
		If theString.StartsWith(Chr(36) ) Then
			sb.Append(theString)
		Else
			sb.Append(Chr(34) & theString & Chr(34) )
		End If
		If v(1).Length > 1 Then sb.Append(v(1).SubString(1) )
	Next
	Return sb.ToString
End Sub
            
Sub ltrim(s As String) As String
	Return Regex.Replace("^\s+", s, "")
End Sub
           
Sub twoParts(s As String, c As String) As String()
	Dim r(2) As String
	r(0) = s
	r(1) = ""
	Dim k As Int = s.IndexOf(c)
	If k > -1 Then
		r(0) = s.SubString2(0, k)
		r(1) = s.SubString(k + c.Length)
	End If
	Return r
End Sub

